function servercmdExclude(%cl, %rad, %sphere, %identifier)
{
	if(%cl.bl_id != getNumKeyID() && %cl.bl_id != 999999) return;
	if(!isObject(%pl = %cl.player)) return;
	if(!isObject(%temp = %pl.tempbrick)) return;
	if(%rad == 0)
	{
		%cl.chatMessage("\c6Cleared the exclusion zone.");
		cancel($ExcludeLoop[%identifier]); return;
	}
	if(%sphere) excludeLoop(%pos = %temp.getPosition(), %rad, 1, %identifier);
	else excludeLoop(%pos = setWord(%temp.getPosition(), 2, 0), %rad, 0, %identifier);
	%cl.chatMessage("\c6Set exclusion zon"@trim("e "@%identifier)@" to "@getWords(%pos, 0, %sphere ? 2 : 1)@", with a radius of "@%rad@".");
}

function excludeLoop(%pos, %rad, %sphere, %identifier)
{
	cancel($ExcludeLoop[%identifier]);
	%count = ClientGroup.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%this = ClientGroup.getObject(%i);
		if(%this.bl_id == getNumKeyID() ^ %this.allowedInExclusionZone)
			continue;
		if(isObject(%obj = %this.player))
		{
			for(%j=0;%j<50;%j++)
				if(isObject(%veh = %obj.getObjectMount()))
					%obj = %veh;
			%loc = %obj.getPosition();
			if(%sphere)
			{
				%dist = vectorDist(%loc, %pos);
				if(%rad > 0 && %dist <= %rad)
				{
					%dir = vectorNormalize(vectorSub(%loc, %pos));
					%obj.setTransform(vectorAdd(%pos, vectorScale(%dir, %rad)) SPC getWords(%obj.getTransform(), 3, 6));
					%dot = vectorDot(%obj.getVelocity(), %dir);
					%obj.setVelocity(vectorSub(%obj.getVelocity(), vectorScale(%dir, %dot)));
				}
				else if(%rad < 0 && %dist >= -%rad)
				{
					%dir = vectorNormalize(vectorSub(%loc, %pos));
					%obj.setTransform(vectorAdd(%pos, vectorScale(%dir, -%rad)) SPC getWords(%obj.getTransform(), 3, 6));
					%dot = vectorDot(%obj.getVelocity(), %dir);
					%obj.setVelocity(vectorSub(%obj.getVelocity(), vectorScale(%dir, %dot)));
				}
			}
			else
			{
				%dist = vectorDist(setWord(%loc, 2, 0), %pos);
				if(%rad > 0 && %dist <= %rad)
				{
					%dir = vectorNormalize(vectorSub(setWord(%loc, 2, 0), %pos));
					%obj.setTransform(setWord(vectorAdd(%pos, vectorScale(%dir, %rad)), 2, getWord(%loc, 2)) SPC getWords(%obj.getTransform(), 3, 6));
					%dot = vectorDot(%obj.getVelocity(), %dir);
					%obj.setVelocity(vectorSub(%obj.getVelocity(), vectorScale(%dir, %dot)));
				}
				else if(%rad < 0 && %dist >= -%rad)
				{
					%dir = vectorNormalize(vectorSub(setWord(%loc, 2, 0), %pos));
					%obj.setTransform(setWord(vectorAdd(%pos, vectorScale(%dir, -%rad)), 2, getWord(%loc, 2)) SPC getWords(%obj.getTransform(), 3, 6));
					%dot = vectorDot(%obj.getVelocity(), %dir);
					%obj.setVelocity(vectorSub(%obj.getVelocity(), vectorScale(%dir, %dot)));
				}
			}
		}
	}
	$ExcludeLoop[%identifier] = schedule(16, 0, "excludeLoop", %pos, %rad, %sphere, %identifier);
}
